<?php
	if (!defined('_PS_VERSION_')) {
		exit;
	}
	include(dirname(__FILE__).'/class/FFVE_SETTINGS.class.php');
	include(dirname(__FILE__).'/class/FFVE_API.class.php');
	include(dirname(__FILE__).'/class/FFVE_TOOLS.class.php');
	include(dirname(__FILE__).'/class/FFVE_UPDATE.class.php');
	include(dirname(__FILE__).'/class/FFVE_TRACKING.class.php');
	class FFVESERVICES extends Module
	{
		private $settings;
		public function __construct()
		{
			$this->name = 'ffveservices';
			$this->tab = 'front_office_features';
			$this->version = '2.6';
			//penser au config.xml
			$this->author = 'DBL France - Fred Fillon';
			$this->need_instance = 0;
			$this->bootstrap = true;
			parent::__construct();
			if (!defined('_FFVE_SERVICES_VERSION_')) {
				define('_FFVE_SERVICES_VERSION_',$this->version);
			}
			if (!defined('_FFVE_MODULE_VERSION_')) {
				define('_FFVE_MODULE_VERSION_', 'PRESTASHOP');
			}
			if (!defined('_FFVE_SERVICES_DEBUG_')) {
				define('_FFVE_SERVICES_DEBUG_', false);
			}
			if (_FFVE_SERVICES_DEBUG_){
				error_log('================ FFVE SERVICES DEBUG ENABLED =================');			
			}	
			if (!defined('_FFVE_DIR')) {
				define('_FFVE_DIR', dirname(__FILE__) . '/');
			}
			// Check if _PS_ADMIN_DIR_ is already defined
			if ( !defined('_FFVE_TMP_DIR_')	){
				if (!defined('_PS_ADMIN_DIR_') ) {
					define('_FFVE_TMP_DIR_', dirname(__FILE__) . '/autoupgrade/tmp/');
					}else{
					define('_FFVE_TMP_DIR_', _PS_ADMIN_DIR_ . '/autoupgrade/tmp/');
				}
			}
			$this->displayName = $this->l('FFVE SERVICES');
			$this->description = $this->l('Permet d\'appliquer une réduction aux membres de FFVE Services et d\'exporter les produits sur FFVE Services.');
			$this->settings = new FFVE_SETTINGS();
		}
		public function install(){
			error_log("Install FFVE");
			// Create configuration settings
			Configuration::updateValue('FFVESERVICES_LOGIN', '');
			Configuration::updateValue('FFVESERVICES_PASSWORD', '');
			Configuration::updateValue('FFVESERVICES_COUPON_CODE', '');
			//$this->AdminMenu();
			$this->installTabs();
			// Créer la nouvelle table
			Db::getInstance()->execute('
			CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'ffveservices_export` (
			`id_product` INT(10) UNSIGNED NOT NULL,
			PRIMARY KEY (`id_product`)
			) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;'
			);
			Db::getInstance()->execute('
			CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'ffveservices_transactions` (
			`id` INT(11) NOT NULL AUTO_INCREMENT,
			`origine` VARCHAR(50) NOT NULL,
			`membre` INT(1) NOT NULL,
			`reference` VARCHAR(50) NOT NULL,
			`totalOrderAmount` DECIMAL(10, 2) NOT NULL,
			`totalQuantity` INT(11) NOT NULL,
			`totalHT` DECIMAL(10, 2) NOT NULL,
			`shippingAmount` DECIMAL(10, 2) NOT NULL,
			`orderStatus` VARCHAR(50) NOT NULL,
			`date_transaction` DATETIME NOT NULL,
			`etat` TINYINT(1) NOT NULL,
			PRIMARY KEY (`id`),
			INDEX (`reference`)
			) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;
			');
			return parent::install() &&
			$this->registerHook('actionDispatcher') &&
			$this->registerHook('actionValidateOrder') &&
			$this->registerHook('actionOrderStatusPostUpdate') &&
			$this->registerHook('displayHeader') &&
			$this->registerHook('displayFooter') &&
			//$this->registerHook('actionCartRuleAdd') &&
			$this->registerHook('displayAdminProductsExtra') &&
			$this->registerHook('displayBackOfficeHeader') &&
			//$this->registerHook('displayAdminMenu') &&
			$this->registerHook('actionProductUpdate') &&
			$this->registerHook('displayShoppingCart');
		}
		public function uninstall()
		{
			// ... your existing uninstall code ...
			// Delete configuration settings
			/*
				Configuration::deleteByName('FFVESERVICES_LOGIN');
				Configuration::deleteByName('FFVESERVICES_PASSWORD');
				Configuration::deleteByName('FFVESERVICES_COUPON_CODE');
			*/
			// Db::getInstance()->execute('DROP TABLE IF EXISTS `'._DB_PREFIX_.'ffveservices_export`');
			error_log('Uninstall FFVE');
			Db::getInstance()->execute('DROP TABLE IF EXISTS `'._DB_PREFIX_.'ffveservices_transactions`');
			if (!parent::uninstall()) {
				return false;
			}
			return $this->uninstallTabs();
		}
		private function uninstallTabs()
		{
			$tabClasses = array('AdminFFVEServices', 'AdminFFVEConfiguration', 'AdminFFVEExport');
			foreach ($tabClasses as $tabClass) {
				$idTab = Tab::getIdFromClassName($tabClass);
				if ($idTab) {
					$tab = new Tab($idTab);
					if (!$tab->delete()) {
						return false;
					}
				}
			}
			return true;
		}
		public function hookDisplayBackOfficeHeader(){
			// if (Tools::getValue('controller') == 'AdminFFVEServices' || Tools::getValue('controller') == 'AdminFFVEConfiguration' || Tools::getValue('controller') == 'AdminFFVEExport') {
			$this->context->controller->addCSS($this->_path.'views/css/admin.css');
			//   }
		}
		private function installTabs() {
			error_log('Install TAB');
			// Main Tab - FFVE Services
			$parentTab = new Tab();
			$parentTab->active = 1;
			$parentTab->class_name = 'AdminFFVEServices';
			$parentTab->name = array();
			foreach (Language::getLanguages() as $lang) {
				$parentTab->name[$lang['id_lang']] = 'FFVE Services';
			}
			$parentTab->id_parent = 0;
			// if (version_compare(_PS_VERSION_, '8.0.0', '<')) {
			// // Si la version de PrestaShop est inférieure à 8.0.0
			// $parentTab->id_parent = Tab::getIdFromClassName('AdminCatalog');
			// } else {
			// // Si la version de PrestaShop est 8.0.0 ou supérieure
			// $parentTab->id_parent = 0;
			// }
			$parentTab->module = $this->name;
			if (!$parentTab->add()) {
				error_log(' ================ Failed to add parent tab ===============');
				return false;
				} else {
				error_log('Parent tab added successfully');
			}
			// Submenu - Configuration
			$configTab = new Tab();
			$configTab->active = 1;
			$configTab->class_name = 'AdminFFVEConfiguration';
			$configTab->name = array();
			foreach (Language::getLanguages() as $lang) {
				$configTab->name[$lang['id_lang']] = 'Configuration';
			}
			$configTab->id_parent = $parentTab->id;
			$configTab->module = $this->name;
			if (!$configTab->add()) {
				error_log(' ================ Failed to add Configuration tab ===============');
				return false;
				} else {
				error_log('Configuration tab added successfully');
			}
			// Submenu - Export produits
			$exportTab = new Tab();
			$exportTab->active = 1;
			$exportTab->class_name = 'AdminFFVEExport';
			$exportTab->name = array();
			foreach (Language::getLanguages() as $lang) {
				$exportTab->name[$lang['id_lang']] = 'Export produits';
			}
			$exportTab->id_parent = $parentTab->id;
			$exportTab->module = $this->name;
			if (!$exportTab->add()) {
				error_log(' ================ Failed to add Export produits tab ===============');
				return false;
				} else {
				error_log('Export produits tab added successfully');
			}
			return true;
		}
		public function hookDisplayAdminProductsExtra($params){
			$productId = (int)Tools::getValue('id_product');
			// Vérifiez si le produit est marqué pour l'export
			$exportStatus = (bool)Db::getInstance()->getValue('
			SELECT 1
			FROM `'._DB_PREFIX_.'ffveservices_export`
			WHERE `id_product` = '.$productId
			);
			$this->context->smarty->assign(array(
			'export_status' => $exportStatus,
			'exportSubMenuUrl' => $this->context->link->getAdminLink('AdminFFVEExport'),
			// 'allSmartyVars' => $allSmartyVars,
			));
			return $this->display(__FILE__, 'views/templates/admin/ffve_export.tpl');
		}
		public function hookActionProductUpdate($params)
		{
			$productId = (int)$params['id_product'];
			$ffveExport = (int)Tools::getValue('ffve_export');
			if ($ffveExport) {
				// Ajouter ou mettre à jour le produit dans la table d'export
				Db::getInstance()->execute('
				REPLACE INTO `'._DB_PREFIX_.'ffveservices_export` (`id_product`)
				VALUES ('.$productId.')
				');
				} else {
				// Supprimer le produit de la table d'export s'il était déjà présent
				Db::getInstance()->delete('ffveservices_export', 'id_product = '.$productId);
			}
		}
		public function getProductsToExport(){
			$result = Db::getInstance()->executeS('
			SELECT id_product
			FROM '._DB_PREFIX_.'ffveservices_export'
			);
			$productIds = array();
			foreach ($result as $row) {
				$productIds[] = $row['id_product'];
			}
			return $productIds;
		}
		public function hookActionDispatcher($params) {
			//Not yet done !
		}
		public function hookDisplayHeader($params) {
			$ffve_tracking=new FFVE_TRACKING();
			$ffve_tracking->handleSourceParam();
		}
		public function hookDisplayFooter($params){
			$ffve_tracking=new FFVE_TRACKING();
			$ffve_tracking->handleFooter();
		}
		public function hookActionOrderStatusPostUpdate($params){
			if (!$this->settings->getModProd()) {
				return;
			}
			// Récupérer l'ID de la commande depuis les paramètres
			$idOrder = isset($params['id_order']) ? (int)$params['id_order'] : 0;
			// error_log("ORDER : " . $idOrder );
			// S'assurer que l'ID de la commande est valide
			if ($idOrder > 0) {
				// Récupérer l'objet Order à partir de l'ID de la commande
				$order = new Order($idOrder);
				if (Validate::isLoadedObject($order)) {
					// L'objet Order est chargé correctement
					$isFFVE = $this->isOrderFFVE($order);
					if ($isFFVE){
						$isFromFFVE = $isFFVE['origine'] == "ffveservices" ? true : false;
						$this->processFFVETransaction($order,"CACHE",$isFromFFVE,$isFFVE['membre']);
					}
				}
			}
		} 
		public function hookActionValidateOrder($params){
			if (!$this->settings->getModProd()) {
				return;
			}
			$isFromFFVE=false;
			$isFFVE=false;
			$code_membre= NULL;
			// Obtenir l'objet cookie de PrestaShop
			$cookie = Context::getContext()->cookie;
			// Vérifier que le cookie 'sourceffve' a été installé correctement
			if (isset($cookie->sourceffve) && $cookie->sourceffve === 'ffveservices') {
				$isFFVE = true;
				$isFromFFVE = true;
			}
			// Vérifier que le cookie 'tokenffve' existe et est valide
			if (isset($cookie->tokenffve)) {
				$isFFVE = true;
				$code_membre = FFVE_TOOLS::dechiffrement($cookie->tokenffve);
			}
			// Récupérer le code de coupon soumis à partir de la commande
			// Dans ce cas on garde le code saisi et non le code envoyé par ffveservices
			$submittedCouponCode = $cookie->submittedCouponCode;
			if (!empty($submittedCouponCode)) {
				$isFFVE = true;
				$code_membre = FFVE_TOOLS::dechiffrement($cookie->submittedCouponCode);
			}
			// Additional checks and validations if needed
			if ($isFFVE) {
				$orderId = $params['order']->id;
				$order = $params['order'];
				// Add a private note to the order
				if ($isFromFFVE){
					$message = 'Source FFVE Services'; // Your private note
					$this->addPrivateMessageToOrder($orderId, $message); // Custom function to add the message
					$this->addPrivateMessageToCustomer($order->id_customer, $orderId, $message);
				}
				// Add a private note to the order
				if ($code_membre){
					$isMembre = true;
					$message = 'Membre FFVE Services'; // Your private note
					$this->addPrivateMessageToOrder($orderId, $message); // Custom function to add the message
					$this->addPrivateMessageToCustomer($order->id_customer, $orderId, $message);
					}else{
					$isMembre = false;
					$code_membre = "INCONNU";
				}
				$this->processFFVETransaction($order,$code_membre,$isFromFFVE,$isMembre);
				// Clear the coupon code from the cookie
				// unset(Context::getContext()->cookie->submittedCouponCode);
			}
		}
		private function isOrderFFVE($order){
			// Vérifier si la commande existe déjà dans la table ffveservices_transactions
			error_log($order->reference);
			$firstTransaction  = Db::getInstance()->getRow('
			SELECT *
			FROM '._DB_PREFIX_.'ffveservices_transactions 
			WHERE reference = "'.pSQL($order->reference).'"
			ORDER BY date_transaction ASC 
			');
			if ($firstTransaction ) {
				return $firstTransaction;
				}else{
				return false;
			}
		}
		private function processFFVETransaction($order,$code_membre,$isFromFFVE,$isMembre){
			// Récupérer les détails de la commande
			$ffveApi = new FFVE_API($this->settings->getServer(), $this->settings->getLogin(), $this->settings->getPassword());
			// Calculer les montants
			$totalOrderAmount = $order->total_paid; // Total TTC incluant la remise
			$totalHT = $order->total_products; // Total HT incluant la remise
			$shippingAmount = $order->total_shipping; // Transport
			// Récupérer le statut de la commande
			if ($order->current_state) {
				$orderStatus = new OrderState($order->current_state);
				$orderStatusName = $orderStatus->name[$order->id_lang]; // Récupération du nom du statut
				} else {
				$orderStatusName = "ON HOLD";
			}
			// Calculer la quantité totale
			$totalQuantity = 0;
			$orderDetails = $order->getOrderDetailList();
			foreach ($orderDetails as $orderDetail) {
				$totalQuantity += $orderDetail['product_quantity'];
			}
			// Construire le payload
			$payload = [
			'submittedCouponCode' => $code_membre ?? 'INCONNU', // Utiliser un coupon ou une valeur par défaut
			'totalOrderAmount' => $totalOrderAmount,  // Total TTC incluant la remise
			'totalQuantity' => $totalQuantity,
			'totalHT' => $totalHT, // Total HT incluant la remise
			'shippingAmount' => $shippingAmount, // Transport
			'orderStatus' => $orderStatusName, // Statut de la commande
			];
			// Appeler l'API
			$res = $ffveApi->setTransaction($order->reference, $payload);
			$etat = @$res['success'] ? 1 : 0;
			// Insérer une ligne dans la table des transactions
			Db::getInstance()->insert('ffveservices_transactions', [
			'origine' => $isFromFFVE ? 'ffveservices' : 'Autre', // ou toute autre origine pertinente
			'membre' => $isMembre ? 1 : 0, // 1 si membre connu, sinon 0
			'reference' => pSQL($order->reference), // Référence de la commande
			'totalOrderAmount' => (float)$totalOrderAmount, // Montant total TTC
			'totalQuantity' => (int)$totalQuantity, // Quantité totale
			'totalHT' => (float)$totalHT, // Montant HT
			'shippingAmount' => (float)$shippingAmount, // Frais de port
			'orderStatus' => pSQL($orderStatusName), // Statut de la commande
			'date_transaction' => date('Y-m-d H:i:s'), // Date actuelle
			'etat' => (int)$etat // État transmission de la transaction (succès ou échec)
			]);
		}
		// Function to add a private note to the customer account
		private function addPrivateMessageToCustomer($customerId, $orderId, $message)
		{
			$id_contact = (int)Db::getInstance()->getValue('SELECT id_contact FROM '._DB_PREFIX_.'contact ORDER BY id_contact ASC');
			if (!$id_contact) {
				// Handle case where no contact is found
				return;
			}
			// Create a new customer thread
			$customerThread = new CustomerThread();
			$customerThread->id_shop = Context::getContext()->shop->id;
			$customerThread->id_customer = (int)$customerId;
			$customerThread->id_order = (int)$orderId;
			$customerThread->id_lang = Context::getContext()->language->id;
			$customerThread->id_contact = $id_contact; // Set the contact ID
			$customerThread->email = "info@ffveservices.com";
			$customerThread->status = 'closed';
			$customerThread->subject = 'Note privée';
			$customerThread->date_add = date('Y-m-d H:i:s');
			$customerThread->token = Tools::passwdGen(12); // Generate a random token
			$customerThread->add(); // Save the thread
			// Add the private message to the customer thread
			$customerMessage = new CustomerMessage();
			$customerMessage->id_customer_thread = (int)$customerThread->id;
			$customerMessage->message = $message;
			$customerMessage->private = 1; // Set to 1 for a private message
			$customerMessage->date_add = date('Y-m-d H:i:s');
			$customerMessage->add(); // Save the message to the database
		}
		// Function to add a private message to the order
		private function addPrivateMessageToOrder($orderId, $message)
		{
			$msg = new Message();
			$msg->message = $message;
			$msg->id_order = (int)$orderId;
			$msg->private = 1; // Set to 1 for a private message
			$msg->add(); // Save the message to the database
		}
		public function hookDisplayShoppingCart($params)
		{
			$isFFVE=$this->ffve_code_membre($params);
			if ($isFFVE){
				$this->context->controller->errors = array();
				return $this->display(__FILE__, 'views/templates/hook/shopping_cart_message.tpl');
			}
		}
		public function ffve_code_membre($params)
		{
			// error_log('CODE MEMBRE');
			if ( ! $this->settings->getModProd() ){
				return;
			}
			// error_log('CODE MEMBRE 1');
			$couponCodeToApply = $this->settings->getCouponCode();
			$context = Context::getContext();
			$submittedCouponCode = Tools::getValue('discount_name');
			$_POST['discount_name']=$_GET['discount_name']=$_REQUEST['discount_name']='';
			if (empty($submittedCouponCode) || $submittedCouponCode==''){
				// error_log('CODE MEMBRE 2');
				// Vérifier si le code coupon FFVE est déjà appliqué
				if ($this->isCouponApplied($context->cart, $couponCodeToApply)) {
					//error_log('FFVE: Code FFVE "' . $couponCodeToApply . '" est déjà appliqué');
					if ( Context::getContext()->cookie->submittedCouponCode == "" ){
						$cartRuleId = CartRule::getIdByCode($couponCodeToApply);
						$context->cart->removeCartRule($cartRuleId);
						if (isset($context->controller)) {
							$context->controller->errors[] = $this->l('Le code de réduction FFVE est réservé aux membres de FFVE Services. La réduction ne sera pas appliquée à la commande.');
						}
						error_log('FFVE: Code FFVE "' . $couponCodeToApply . '" ne doit pas être appliqué et a été supprimé');
					}
					} else {
					// error_log('FFVE: Aucun code de réduction soumis et aucun code FFVE n\'est appliqué');
				}
				return;
			}
			if (!empty($submittedCouponCode) && $submittedCouponCode!=''){
			    // error_log('CODE MEMBRE 3');
				$cartRuleId = CartRule::getIdByCode($submittedCouponCode);
				if ( $couponCodeToApply == $submittedCouponCode){
					// error_log('CODE MEMBRE 4');
					// error_log('CODE FFVE');
					// Si le code soumis est celui à appliquer, nous devons le supprimer
					$cartRuleId = CartRule::getIdByCode($submittedCouponCode);
					if ($cartRuleId) {
						// Supprimer la règle de panier associée au code coupon
						$context->cart->removeCartRule($cartRuleId);
						error_log('FFVE: Code FFVE "' . $submittedCouponCode . '" ne doit pas être appliqué et a été supprimé');
					}
					return;
				}
				if ( $cartRuleId ){
					return;
				}
			}
			// Check if the order total is greater than 0 and FFVELOCAL is not already applied
			if ($context->cart->getOrderTotal() > 0 && !$this->isCouponApplied($context->cart, $couponCodeToApply)) {
				// Check if the user has entered a coupon code
				$ffveApi = new FFVE_API($this->settings->getServer(),$this->settings->getLogin(),$this->settings->getPassword());
				if (!empty($submittedCouponCode) && $ffveApi->checkCouponCodeExists($submittedCouponCode) ) {
					// FFVE coupon is entered, apply the FFVELOCAL coupon
					$cartRuleId = CartRule::getIdByCode($couponCodeToApply);
					if ($cartRuleId) {
						$cartRule = new CartRule($cartRuleId);
						$context->cart->addCartRule($cartRule->id);
						// Clear existing error and confirmation messages
						$context->controller->errors = array();
						$context->controller->confirmations = array();
						// Recalculate cart rules
						$context->cart->getCartRules(true);
						// Assign message for display
						$context->smarty->assign('discount_name', $cartRule->description);
						Context::getContext()->cookie->submittedCouponCode = FFVE_TOOLS::chiffrement($submittedCouponCode);
						return true;
					}
					} else {
					return false;
					// If the submitted coupon code is not FFVE do nothing
				}
			}
		}
		/**
			* Check if a specific coupon is applied to the cart.
			*
			* @param Cart $cart
			* @param string $couponCode
			* @return bool
		*/
		public function isCouponApplied($cart, $couponCode)
		{
			foreach ($cart->getCartRules() as $cartRule) {
				if ($cartRule['code'] === $couponCode) {
					return true;
				}
			}
			return false;
		}
		public function getContent()
		{
			$output = '';
			if (Tools::isSubmit('submit_update_plugin')) {
				$ffve_update = new FFVE_UPDATE($this->name, $this->version);
				$update = $ffve_update->check_for_update(new stdClass());
				if (isset($update->response[$this->name]->package)) {
					$plugin_url = $update->response[$this->name]->package;
					$result = $ffve_update->applyUpdate($plugin_url);
					if ($result) {
						$output .= $this->displayConfirmation($this->l('Le plugin a été mis à jour avec succès.'));
						} else {
						$output .= $this->displayError($this->l('La mise à jour du plugin a échoué.'));
					}
					} else {
					$output .= $this->displayError($this->l('Aucune mise à jour disponible.'));
				}
			}
			if (Tools::getValue('login_ffve')) {
				$login = Tools::getValue('login_ffve');
				if (Tools::getValue('password_ffve'))
				$password = hash('sha256', Tools::getValue('password_ffve'));
				else
				$password = NULL;
				$couponCode = Tools::getValue('coupon_code');
				$modProd = Tools::getValue('mode_prod');
				$server = Tools::getValue('server');
				// Validate and save the settings
				// Add your validation logic here if needed
				$this->settings->setLogin($login);
				if ($password != '')
				$this->settings->setPassword($password);
				$this->settings->setCouponCode($couponCode);
				$this->settings->setModProd($modProd);
				$this->settings->setServer($server);
				Configuration::updateValue('FFVESERVICES_LOGIN', $login);
				if ($password != '')
				Configuration::updateValue('FFVESERVICES_PASSWORD', $password);
				Configuration::updateValue('FFVESERVICES_COUPON_CODE', $couponCode);
				Configuration::updateValue('FFVE_MOD_PROD', $modProd);
				Configuration::updateValue('FFVE_SERVER', $server);
				$output .= $this->displayConfirmation($this->l('Mise à jour des informations effectuée.'));
			}
			if (!Tools::getValue('submit_checkconfig') && Tools::getValue('login_ffve')) {
				$api = new FFVE_API($this->settings->getServer(), $this->settings->getLogin(), $this->settings->getPassword());
				// Appel de la méthode checkconfig()
				$result = $api->checkConfig();
				if ($result['success']) {
					$output .= $this->displayConfirmation($this->l('Configuration vérifiée avec succès.'));
					} else {
					$output .= $this->displayError($this->l('La vérification de la configuration a échoué : ' . str_replace("<br>"," >>> ", $result['message']) ));
				}
			}
			// Display the form
			$output .= '<style>#login_ffve{max-width:200px;}</style>';
			$output .= $this->renderForm();
			if (!Tools::isSubmit('submit_update_plugin')){
				$ffve_update = new FFVE_UPDATE($this->name, $this->version);
				$update = $ffve_update->check_for_update(new stdClass());
				if (isset($update->response[$this->name]->new_version)) {
					$output .= $this->displayConfirmation('Une nouvelle version du plugin est disponible.<br>Vous utilisez la version ' . $this->version . ', la version ' . $update->response[$this->name]->new_version . ' est disponible');
					$output .= '<form method="post">
					<button type="submit" name="submit_update_plugin" class="btn btn-primary">' . $this->l('Mettre à jour le plugin') . '</button>
					</form>';
				}
			}
			return $output;
		}
		private function renderForm()
		{
			// Fetch active coupon codes
			$activeCouponCodes = $this->getActiveCouponCodes();
			$fields_form[0]['form'] = array(
			'legend' => array(
			'title' => $this->l('FFVE SERVICES'),
			'icon' => 'icon-cogs',
			),
			'description' => $this->l('Indiquez votre indentifiant FFVE Services et votre mot de passe.').'<br/>'.
			$this->l('Choisissez le code coupon qui sera assigné aux membres de FFVE Services').'<br/>',
			'input' => array(
			array(
			'type' => 'text',
			'label' => $this->l('Identifiant : '),
			'name' => 'login_ffve',
			'icon' => 'icon-user',
			'size'=> 20,
			'required' => true,
			),
			array(
			'type' => 'password',
			'label' => $this->l('Mot de passe : '),
			'name' => 'password_ffve',
			'required' => true,
			),
			array(
			'type' => 'select', 
			'label' => $this->l('Code de réduction : '),
			'name' => 'coupon_code',
			'options' => array(
			'query' => $activeCouponCodes,
			'id' => 'id',
			'name' => 'name',
			),
			),
			array(
			'type' => 'switch',
			'label' => $this->l('Mode production'),
			'name' => 'mode_prod',
			'is_bool' => true,
			'values' => array(
			array(
			'id' => 'mode_prod_on',
			'value' => 1,
			'label' => $this->l('Oui'),
			),
			array(
			'id' => 'mode_prod_off',
			'value' => 0,
			'label' => $this->l('Non'),
			),
			),
			),
			array(
			'type' => 'radio',
			'label' => $this->l('Serveur API FFVE Services :'),
			'name' => 'server',
			'desc' => $this->l('Vous pouvez utiliser le serveur de production uniquement après avoir eu la validation de FFVE Services'),
			'values' => array(
			array(
			'id' => 'version_2_1_test',
			'value' => 'dev.ffveservices.com',
			'label' => $this->l('Version mode test')
			),
			array(
			'id' => 'version_2_1_production',
			'value' => 'api.ffveservices.com',
			'label' => $this->l('Version mode production'),
			),
			),
			),
			),
			'submit' => array(
			'title' => $this->l('Save'),
			'class' => 'btn btn-default pull-right',
			),
			'buttons' => array(
			'checkconfig' => array(
			'title' => '<i class="process-icon-cogs"></i> ' . $this->l('Vérifier la configuration'), // Ajout de l'icône
			'type' => 'submit',
			'value' => 'checkconfig',
			'class' => 'btn btn-primary pull-right', // Changer la couleur du bouton en utilisant une classe CSS différente
			'name' => 'submit_checkconfig', // nom pour détecter le bouton
			),
			),
			);
			$helper = new HelperForm();
			$helper->module = $this;
			$helper->name_controller = $this->name;
			$helper->token = Tools::getAdminTokenLite('AdminModules');
			$helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;
			$helper->default_form_language = $this->context->language->id;
			$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG', 0);
			$helper->fields_value['login_ffve'] = $this->settings->getLogin();
			$helper->fields_value['password_ffve'] = $this->settings->getPassword();
			$helper->fields_value['coupon_code'] = $this->settings->getCouponCode();
			$helper->fields_value['mode_prod'] = $this->settings->getModProd();
			$helper->fields_value['server'] = $this->settings->getServer();
			$helper->submit_action = 'submit_checkconfig';
			return $helper->generateForm($fields_form);
		}
		// Function to fetch active coupon codes
		private function getActiveCouponCodes()
		{
			$couponCodes = array();
			$CartRule = new CartRule();
			$cart_rules     = $CartRule->getAssociatedRestrictions('cart_rule', true, true, NULL, NULL, '');
			foreach ($cart_rules['selected'] as $cart_rule) {
				$couponCodes[]=array('id'=>$cart_rule['code'], 'name'=>$cart_rule['code']);
			}
			return $couponCodes;
		}
	}																																		